{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Operationen für verkettete Listen implementieren (Teil 1)\n",
    "\n",
    "In diesem Notebook wirst du die Operationen der Klasse `VerketteteListe` implementieren, \n",
    "s. {numref}`fig_kd_verkettete_liste`.\n",
    "\n",
    "Automatische Tests werden dir dabei helfen, deine Implementierungen zu überprüfen. Diese \n",
    "Tests werden weiter unten definiert. Wie genau sie arbeiten ist für dich nicht wichtig; du\n",
    "musst nur sicherstellen, dass du die Operationen der Klasse `VerketteteListe` so implementierst,\n",
    "dass die Tests erfolgreich durchgeführt werden.\n",
    "\n",
    "**Hinweis:** \n",
    "- Lade dieses Notebook von der Webseite herunter und bearbeite es auf deinem Computer. \n",
    "- Führe mit **Run All** das gesamte Notebook am Anfang einmal aus. Dadurch werden die Tests definiert, mit denen du deinen Fortschritt beim Bearbeiten der Übungen überprüfen kannst.\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "metadata": {
    "tags": [
     "hide-cell"
    ]
   },
   "outputs": [],
   "source": [
    "# DIESE TESTS BITTE NICHT VERÄNDERN\n",
    "\n",
    "class TestsVerketteteListe:\n",
    "    def __init__(self, KlasseVerketteteListe):\n",
    "        self.ZuTestendeKlasse = KlasseVerketteteListe\n",
    "        tests = [methode for methode in dir(self) if methode.startswith('teste') and callable(getattr(self, methode))]\n",
    "        self.anzahl_tests = len(tests)\n",
    "        self.bestandene_tests = 0\n",
    "\n",
    "    def erfolgreicher_test(self, methodenname):\n",
    "        self.bestandene_tests += 1\n",
    "        print(f\"  {methodenname} war erfolgreich. Aktuelle Punktzahl: {self.bestandene_tests}/{self.anzahl_tests}\")\n",
    "\n",
    "    def fuehre_tests_aus(self, reihenfolge: list[str]):\n",
    "        print(\"Mögen die Tests beginnen!\")\n",
    "        for test_name in reihenfolge:\n",
    "            test_name = \"teste_\" + test_name\n",
    "            if not hasattr(self, test_name):\n",
    "                print(f\"Test {test_name} existiert nicht.\")\n",
    "                continue\n",
    "            test_methode = getattr(self, test_name)\n",
    "            print(f\"Starte Test: {test_name}...\")\n",
    "            # Fange Fehler ab und gib die Fehlermeldung aus\n",
    "            try:\n",
    "                test_methode()\n",
    "            except AssertionError as e:\n",
    "                print(f\"  {test_name} fehlgeschlagen: {e}\")\n",
    "                break\n",
    "            self.erfolgreicher_test(test_name)\n",
    "        if self.bestandene_tests == self.anzahl_tests:\n",
    "            print(\"\\nHerzlichen Glückwunsch! Alle Tests erfolgreich.\")\n",
    "        else:\n",
    "            print(\"\\nLeider waren noch nicht alle Tests erfolgreich. Probiere es noch einmal!\")\n",
    "\n",
    "    def beispiel_liste(self):\n",
    "        # print(\"Liste vorbereiten\")\n",
    "        test_liste = self.ZuTestendeKlasse()\n",
    "        test_liste.einfuegen_vorne(\"Anna\")   # Diese Methode existiert schon\n",
    "        test_liste.einfuegen_vorne(\"Bibi\")\n",
    "        test_liste.einfuegen_vorne(\"Coco\")\n",
    "        test_liste.einfuegen_vorne(\"Dina\")\n",
    "        # print(\"Die Liste sieht am Anfang so aus:\", test_liste)\n",
    "        return test_liste\n",
    "    \n",
    "    def teste_ist_leer(self):\n",
    "        leere_liste = self.ZuTestendeKlasse()\n",
    "        assert leere_liste.ist_leer() == True, \"Ein leere verkettete Liste wurde nicht als leer erkannt. Tipp: Die Methode ist_leer() sollte True zurückgeben, wenn der Kopf der Liste None ist.\"    \n",
    "        liste = self.beispiel_liste()\n",
    "        assert liste.ist_leer() == False, \"Für eine Liste, die Elemente enthält, hat die Methode ist_leer() False zurückgegeben.\"\n",
    "\n",
    "    def teste_anzahl_elemente(self):\n",
    "        leere_liste = self.ZuTestendeKlasse()\n",
    "        korrekt = 0\n",
    "        ergebnis = leere_liste.anzahl_elemente()\n",
    "        assert ergebnis == korrekt, f\"Die korrekte Anzahl der Elemente in einer leeren Liste ist 0, aber deine Methode gibt {ergebnis} zurück.\"    \n",
    "        liste = self.beispiel_liste()\n",
    "        korrekt = 4\n",
    "        ergebnis = liste.anzahl_elemente()\n",
    "        assert ergebnis == korrekt, f\"Die korrekte Anzahl der Elemente in der Liste ist {korrekt}, aber deine Methode gibt {ergebnis} zurück.\"\n",
    "\n",
    "    def teste_gib_inhalt(self):\n",
    "        liste = self.beispiel_liste()\n",
    "        erwartet = \"Dina\"\n",
    "        erhalten = liste.gib_inhalt(0)\n",
    "        # sicherstellen, dass kein Typ Knoten zurückgegeben wird\n",
    "        assert type(erhalten) != Knoten, f\"Die Methode gib_inhalt() sollte den Inhalt des Knotens zurückgeben, nicht den Knoten selbst.\"\n",
    "        assert erhalten == erwartet, f\"Das erste Element sollte {erwartet} sein, ist aber {erhalten}.\"\n",
    "        erwartet = \"Coco\"\n",
    "        erhalten = liste.gib_inhalt(1)\n",
    "        assert erhalten == erwartet, f\"Das zweite Element sollte {erwartet} sein, ist aber {erhalten}.\"\n",
    "        erwartet = \"Anna\"\n",
    "        erhalten = liste.gib_inhalt(3)\n",
    "        assert erhalten == erwartet, f\"Das letzte Element sollte {erwartet} sein, ist aber {erhalten}.\"\n",
    "\n",
    "    def teste_ersetzen(self):\n",
    "        liste = self.beispiel_liste()\n",
    "        liste.ersetzen(0, \"Ella\")\n",
    "        erwartet = \"Ella -> Coco -> Bibi -> Anna\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Nach dem Ersetzen des ersten Elements sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste.ersetzen(1, \"Fiona\")\n",
    "        erwartet = \"Ella -> Fiona -> Bibi -> Anna\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Nach dem Ersetzen des zweiten Elements sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste.ersetzen(3, \"Greta\")\n",
    "        erwartet = \"Ella -> Fiona -> Bibi -> Greta\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Nach dem Ersetzen des letzten Elements sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 8,
   "metadata": {},
   "outputs": [],
   "source": [
    "# Die Klasse Knoten werden wir in dieser Aufgabe benutzen, aber nicht verändern.\n",
    "# Es gilt weiterhin: Ein Knoten speichert einen Inhalt und eine Referenz auf den nächsten Knoten.\n",
    "\n",
    "from __future__ import annotations   # brauchen wir, weil wir in der Klasse Knoten den Typ Knoten verwenden\n",
    "from typing import Any\n",
    "\n",
    "class Knoten:\n",
    "    def __init__(self, inhalt):\n",
    "        \"\"\" Konstruktor für die Klasse Knoten: speichert den Inhalt und legt\n",
    "        eine Referenz auf den nächsten Knoten an. \"\"\"\n",
    "        self.inhalt: Any = inhalt   # Any = inhalt kann beliebiger Datentyp sein\n",
    "        self.naechster: Knoten|None = None    # Typ-Annotation: naechster ist ein Knoten oder None\n",
    "\n",
    "    def __str__(self):\n",
    "        return str(self.inhalt)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Jetzt geht's los! Implementiere in der folgenden Zelle nach und nach die fehlenden Operationen/Methoden. Immer wenn du mit einer Methode fertig bist, führe die Zelle aus um zu prüfen, ob die Tests zu dieser Methode jetzt bestanden werden."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 9,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Mögen die Tests beginnen!\n",
      "Starte Test: teste_ist_leer...\n",
      "  teste_ist_leer fehlgeschlagen: Ein leere verkettete Liste wurde nicht als leer erkannt. Tipp: Die Methode ist_leer() sollte True zurückgeben, wenn der Kopf der Liste None ist.\n",
      "\n",
      "Leider waren noch nicht alle Tests erfolgreich. Probiere es noch einmal!\n"
     ]
    }
   ],
   "source": [
    "class VerketteteListe:\n",
    "    def __init__(self):\n",
    "        self.erster: Knoten|None = None   # Der erste Knoten in der Liste (Listenkopf)    \n",
    "\n",
    "    def __str__(self) -> str:\n",
    "        \"\"\" Gibt die Liste als Zeichenkette, getrennt durch Pfeile, zurück. \"\"\"\n",
    "        inhalte = []\n",
    "        knoten = self.erster\n",
    "        while knoten is not None:\n",
    "            inhalte.append(knoten.inhalt)\n",
    "            knoten = knoten.naechster\n",
    "        return \" -> \".join(inhalte)\n",
    "\n",
    "    def einfuegen_vorne(self, pInhalt):\n",
    "        \"\"\"Fügt einen neuen Knoten mit pInhalt am Anfang der Liste ein.\"\"\"\n",
    "        neu = Knoten(pInhalt)   # \"Verpacke\" den Inhalt in einen Knoten\n",
    "        neu.naechster = self.erster  # Nachfolger des neuen Knotens ist der bisherige Listenkopf\n",
    "        self.erster = neu  # Der neue Knoten ist ab jetzt der Listenkopf\n",
    "\n",
    "   # AUFGABE: Implementiere die folgenden Methoden für die Klasse VerketteteListe:\n",
    "    \n",
    "    def ist_leer(self) -> bool:\n",
    "        \"\"\"gibt True zurück, wenn die Liste leer ist, sonst False\"\"\"\n",
    "        ...  # Hier Lösung ergänzen\n",
    "\n",
    "    def anzahl_elemente(self) -> int:\n",
    "        \"\"\" Gibt die Anzahl der Elemente in der Liste zurück. \"\"\"\n",
    "        ...  # Hier Lösung ergänzen\n",
    "    \n",
    "    def gib_inhalt(self, index: int) -> Any:\n",
    "        \"\"\" Gibt den Inhalt des Knotens an der Stelle index zurück. \"\"\"\n",
    "        # ACHTUNG: Gib nicht den Knoten selbst zurück, sondern nur den Inhalt!\n",
    "        # D.h. dein Code sollte sowas enthalten wie: return aktuell.inhalt\n",
    "        ...  # Hier Lösung ergänzen\n",
    "    \n",
    "    def ersetzen(self, index, neuer_inhalt: Any) -> None:\n",
    "        \"\"\" Ersetzt den Inhalt des Knotens an der Stelle index durch neuer_inhalt. \"\"\"\n",
    "        ...  # Hier Lösung ergänzen\n",
    "\n",
    "\n",
    "\n",
    "# Mit den folgenden Tests kannst du deine Implementierung überprüfen.\n",
    "# Führe einfach diese Zelle aus, um die Tests zu starten.\n",
    "\n",
    "test = TestsVerketteteListe(VerketteteListe)\n",
    "reihenfolge = [\"ist_leer\", \"anzahl_elemente\", \"gib_inhalt\", \"ersetzen\"]\n",
    "test.fuehre_tests_aus(reihenfolge)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "```{margin}\n",
    "Du kommst gar nicht weiter? Dann wirf trotzdem schon einen Blick in Teil 2. Dort findest du auch die Musterlösungen für die Aufgaben hier.\n",
    "```\n",
    "\n",
    "Hat dein Code alle Tests bestanden? Dann herzlichen Glückwunsch! Du bist bereit für Teil 2."
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.12.3"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
